#include "Mutex.hh"
#include "Thread.hh"


Mutex::Mutex() {
	int res=pthread_mutex_init(&mutex_,NULL);
	if(res!=0) {
		throw ThreadError("can't create mutex...");
	}
}

void Mutex::lock() {
	int res=pthread_mutex_lock(&mutex_);
	if(res!=0) {
		throw ThreadError("can't lock mutex...");
	}
}

void Mutex::unlock() {
	int res=pthread_mutex_unlock(&mutex_);
	if(res!=0) {
		throw ThreadError("can't unlock mutex...");
	}
}
