#include "Thread.hh"

ThreadError::ThreadError(const std::string& message)
	: message_(message)
{}

const std::string& ThreadError::get_message() const {
	return message_;
}

Thread::Thread() 
	: thread_id_(0)
{}

void* Thread::internal_run(void* arg) {
	Thread* thread=static_cast<Thread*>(arg);
	thread->run();
	return NULL;
}

void Thread::start() {
	int res=pthread_create(&thread_id_,NULL,
		Thread::internal_run,this);
	if(res!=0) {
		throw ThreadError("can't create thread...");
	}
}
